--
-- Relevage
--
-- written by fruktor, visit: www.eifok-team.de
--

Relevage = {};

Relevage.modDir = g_currentModDirectory;

function Relevage.prerequisitesPresent(specializations)
    return true; 
end;

function Relevage:load(xmlFile)

	self.playerCallbackRAV = SpecializationUtil.callSpecializationsFunction("playerCallbackRAV"); 
	
	self.RAV = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(xmlFile, string.format("vehicle.Relevage#trigger")) );
	if trigger == nil then
		print("[Error::Relevage] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(xmlFile, string.format("vehicle.Relevage#icIndex", i));
	
	self.RAV.icIndex = icIndex;
	self.RAV.trigger = trigger;
	self.RAV.plIR = false;
		
	addTrigger( trigger, "playerCallbackRAV", self );				
	
end;

function Relevage:delete()
	if self.RAV.trigger ~= nil then
		removeTrigger(self.RAV.trigger);
	end;
end;

function Relevage:readStream(streamId, connection)
end;

function Relevage:writeStream(streamId, connection)
end;

function Relevage:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Relevage:keyEvent(unicode, sym, modifier, isDown)
end;

function Relevage:update(dt)
	
	if self.RAV.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_RELEVAGE"), InputBinding.SET_RELEVAGE );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_RELEVAGE") );
		if InputBinding.hasEvent(InputBinding.SET_RELEVAGE)then
			local obj = self.interactiveObjects[self.RAV.icIndex];
			if obj ~= nil then
				--self.setDoor(not obj.isOpen);
				self:doActionOnObject(self.RAV.icIndex);
			end;
			
			--self.vehicle:playAnimation(self.animation, dir, Utils.clamp(self.vehicle:getAnimationTime(self.animation), 0, 1), true);
		end
	end;
end;

function Relevage:onLeave()
end;

function Relevage:draw()
end;

function Relevage:playerCallbackRAV(triggerId, otherId, onEnter, onLeave, onStay)
	
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.RAV.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.RAV.plIR = false;
	end;
	
end;

